#include "SoXtOLDialog.h"
#include "SoXtWebViewer.h"
#include "WebCB.h"

#include <iostream.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoWWWInline.h>

#define DEFAULT_URL "http://mordillo.npac.syr.edu:8888/vrml/demo"

SoXtOLDialog::SoXtOLDialog( SoXtWebViewer* viewer, Widget parent,
			   const char* name, SbBool buildInsideParent )
: SoXtComponent( parent, name, buildInsideParent )
  {
     Arg args[5];
     int nArgs = 0;
     XmString string = XmStringCreateSimple( "Open" );
     XtSetArg( args[nArgs], XmNokLabelString, string ); nArgs++;
     XmString string2 = XmStringCreateSimple( "Open Location:" );
     XtSetArg( args[nArgs], XmNselectionLabelString,string2); nArgs++;
     XmString string3 = XmStringCreateSimple( DEFAULT_URL );
     XtSetArg( args[nArgs], XmNtextString, string3 ); nArgs++;
     XtSetArg( args[nArgs], XmNwidth, DIALOG_WIDTH ); nArgs++;
     XtSetArg( args[nArgs], XmNautoUnmanage, TRUE ); nArgs++;
     locationDialog = XmCreatePromptDialog( parent, "Open Location", args, nArgs );

     Widget w = XmSelectionBoxGetChild( locationDialog, XmDIALOG_HELP_BUTTON );
     XtUnmanageChild( w );
     
     XtAddCallback( locationDialog, XmNokCallback, ( XtCallbackProc )OpenLocationCB, viewer );
     XmStringFree( string );
     XmStringFree( string2 );
     XmStringFree( string3 );
     setBaseWidget( locationDialog );
  }

void
SoXtOLDialog::OpenLocationCB( Widget w, SoXtWebViewer* viewer, 
			      XmSelectionBoxCallbackStruct* cbs )
  {
     char *text;
     if( XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &text) )
       {
	  if( strcmp( text, "" ) )
	    {
	       if( strncmp( text, "http://", 7 ) && strncmp( text, "file:", 5 ) )
		 {
		    char fullURL[1024];
		    strcpy( fullURL, "http://" );
		    strcat( fullURL, text );
		    text = fullURL;
		 }
	       LoadGraph( text, viewer );
	    }
	  else
	     viewer->showErrorMsg( "OpeningError", "Empty URL" );
       }
     else 
	viewer->showErrorMsg( "Error", "Smth is wrong, try again" );

     XtPopdown( XtParent( w ) );
#ifdef DEBUG
     cerr << "OpenLocationCB end\n";
#endif
  }
